;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;											  ;
;Tile Map demo/source v1.0 made by Bob Benson ;
;  send any comments to "whishkah@yahoo.com"  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "TileMap demo v1.0 by:Bob Benson",0

ProgStart:


	call _clrLCD		;clears the screen and video memery
	call _runindicoff	;turns off the busy indicator

	ld hl, Map
	call DrawMap

PauseLoop:
	call _getkey
	jr z, PauseLoop		;this tells the calc to wait until a key is pressed.
	call _clrLCD
	ret

DrawMap:
	ld de, $0000		;start to draw at (0,0)

DrawMapL:
	push hl				;save pointer
	ld l,(hl)			;get current tile
	ld h, 0				;clear upper byte
	add hl,hl			;*2
	add hl,hl			;*4		BETTER THAN MULTIPLIING
	add hl,hl			;*8
	ld bc, Sprites		;start to get sprites
	add hl,bc			;get the correct sprite (add)
	push de				;save location for sprite
	call GridPutSprite	;draw sprite
	pop de				;restore draw location
	pop hl				;restore pointer
	inc hl				;next line
	inc e				;move to the right ->
	bit 4,e				;if the bit #5 (e=16) stop drawing
	jr z, DrawMapL		;only jump if the row is not finished
	ld e,0				;draw at the left
	inc d				;move down a row
	bit 3,d				;check if done
	ret nz				;return if finished
	jr DrawMapL			;go to top of loop

GridPutSprite:
	push hl
	pop ix				;sprite
	srl d
	rra
	and $80
	or e
	ld e,a
	ld hl,$fc00			;video ram(memory)
	add hl,de			;video ram + the offset
	ld b,8				;initialize the loop counter
	ld de, $10
GPS_Loop:
	ld a,(ix+0)			;get a byte for the sprite
	ld (hl),a			;put it on screen
	inc ix				;get next byte in sprite
	add hl, de			;move to next line
	djnz GPS_Loop
	ret

Map:
	.db $0,$0,$0,$0,$0,$0,$0,$0,$0,$1,$2,$0,$0,$0,$0,$0		;
	.db $0,$0,$1,$2,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0		;
	.db $0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$1,$2,$0,$0,$0		;
	.db $3,$3,$0,$0,$0,$0,$0,$7,$0,$0,$0,$0,$0,$0,$3,$3		;The tilemap
	.db $3,$3,$0,$0,$0,$0,$0,$6,$0,$0,$0,$0,$0,$0,$3,$3		;itself
	.db $3,$3,$3,$3,$0,$0,$0,$6,$0,$0,$0,$0,$3,$3,$3,$3		;
	.db $3,$3,$3,$3,$0,$8,$0,$5,$0,$9,$A,$0,$3,$3,$3,$3		;
	.db $4,$4,$4,$4,$4,$4,$4,$4,$4,$4,$4,$4,$4,$4,$4,$4		;

Sprites:													;these are the sprites that will
															;be used in the map
Sprite0:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000


Sprite1:
	.db %00000000
	.db %00000110
	.db %01101001
	.db %10010000
	.db %10000110
	.db %01010000
	.db %00101001
	.db %00000110

Sprite2:
	.db %00000000
	.db %00101100
	.db %11010010
	.db %00000001
	.db %01100001
	.db %00001010
	.db %10010100
	.db %01100000

Sprite3:
	.db %11111111
	.db %00010001
	.db %11111111
	.db %10001000
	.db %11111111
	.db %00010001
	.db %11111111
	.db %10001000

Sprite4:
	.db %01111110
	.db %10000001
	.db %10100101
	.db %10011001
	.db %10011001
	.db %10100101
	.db %10000001
	.db %01111110

Sprite5:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00011100
	.db %00111110
	.db %00111110
	.db %00111110
	.db %00111110

Sprite6:
	.db %00001000
	.db %00001000
	.db %00001000
	.db %00001000
	.db %00001000
	.db %00001000
	.db %00001000
	.db %00001000

Sprite7:
	.db %00011000
	.db %00101000
	.db %01001000
	.db %10001000
	.db %01001000
	.db %00101000
	.db %00011000
	.db %00001000

Sprite8:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000100
	.db %00101000
	.db %10011010
	.db %01111100
	.db %00111000

Sprite9:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000010
	.db %00001001
	.db %00100101
	.db %00011111
	.db %00000111

SpriteA:
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00001000
	.db %01010000
	.db %10010100
	.db %11111000
	.db %11100000


	call _homeup										;move the cursor to the top 
														;left of the screen

.end
